#ifndef ELM_INTERFACE_ATSPI_WIDGET_ACTION_EO_HH
#define ELM_INTERFACE_ATSPI_WIDGET_ACTION_EO_HH
#include <Eo.h>

extern "C" {
#include "elm_interface_atspi_action.eo.h"
#include "elm_interface_atspi_widget_action.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "elm_interface_atspi_action.eo.hh"
namespace elm { namespace interface { 
struct Atspi_Widget_Action;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::elm::interface::Atspi_Widget_Action> : ::std::true_type {}; } }

namespace eo_cxx {
namespace elm { namespace interface { 
struct Atspi_Widget_Action {
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_WIDGET_ACTION_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::elm::interface::Atspi_Widget_Action() const;
   operator ::elm::interface::Atspi_Widget_Action&();
   operator ::elm::interface::Atspi_Widget_Action const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Atspi_Widget_Action,  ::elm::interface::Atspi_Action> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Atspi_Widget_Action const ,  ::elm::interface::Atspi_Action const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace elm { namespace interface { 
struct Atspi_Widget_Action : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::elm ::interface::Atspi_Action)
{
   explicit Atspi_Widget_Action( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Atspi_Widget_Action(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Atspi_Widget_Action(Atspi_Widget_Action const& other) = default;
   Atspi_Widget_Action(Atspi_Widget_Action&& other) = default;
   Atspi_Widget_Action& operator=(Atspi_Widget_Action const& other) = default;
   Atspi_Widget_Action& operator=(Atspi_Widget_Action&& other) = default;
   Atspi_Widget_Action()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Atspi_Widget_Action( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Atspi_Widget_Action(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return ELM_INTERFACE_ATSPI_WIDGET_ACTION_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Atspi_Widget_Action,  ::elm::interface::Atspi_Action> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Atspi_Widget_Action const ,  ::elm::interface::Atspi_Action const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Atspi_Widget_Action) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Atspi_Widget_Action>::value, "");
} } 
#include "elm_interface_atspi_widget_action.eo.impl.hh"
#endif
